function createPed(model, locationx, locationy, locationz)
    local hash = model
    while not HasModelLoaded(hash) do
        RequestModel(hash)
        Citizen.Wait(1)
    end
    return CreatePed(26, hash, locationx, locationy, locationz, 0, true, false)
end

function start()
    local screenX = GetDisabledControlNormal(0, 239)
    local screenY = GetDisabledControlNormal(0, 240)

    clonedPed = createPed(GetEntityModel(PlayerPedId()), nil, nil, nil)
    SetEntityCollision(clonedPed, false, true)
    SetEntityInvincible(clonedPed, true)
    NetworkSetEntityInvisibleToNetwork(clonedPed, true)
    ClonePedToTarget(PlayerPedId(), clonedPed)
    SetEntityCanBeDamaged(clonedPed, false)
    SetBlockingOfNonTemporaryEvents(clonedPed, true)

    local positionBuffer = {}
    local bufferSize = 5

    while true do 
        local world, normal = GetWorldCoordFromScreenCoord(0.67135417461395, 0.7787036895752)
        local depth = 3.5
        local target = world + normal * depth
        local camRot = GetGameplayCamRot(2)

        table.insert(positionBuffer, target)
        if #positionBuffer > bufferSize then
            table.remove(positionBuffer, 1)
        end

        local averagedTarget = vector3(0, 0, 0)
        for _, position in ipairs(positionBuffer) do
            averagedTarget = averagedTarget + position
        end
        averagedTarget = averagedTarget / #positionBuffer

        SetEntityCoords(clonedPed, averagedTarget.x, averagedTarget.y, averagedTarget.z, false, false, false, true)
        SetEntityHeading(clonedPed, camRot.z + 180.0)
        SetEntityRotation(clonedPed, camRot.x*(-1), 0, camRot.z + 180.0, false, false)

        Citizen.Wait(0)
    end
end

local visPed = false

RegisterCommand('startVisPed', function()
    visPed = not visPed 
    if visPed then 
        start()
    else     
        DeleteEntity(clonedPed)
    end 
end)

exports('Whbl_ped_start', function()
    start()
end)

exports('Whbl_ped_close', function()
    DeleteEntity(clonedPed)
end)

AddEventHandler('onResourceStop', function(resourceName)
    DeleteEntity(clonedPed)
end)